// cog_ram

/*
-------------------------------------------------------------------------------
Copyright 2014 Parallax Inc.

This file is part of the hardware description for the Propeller 1 Design.

The Propeller 1 Design is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by the
Free Software Foundation, either version 3 of the License, or (at your option)
any later version.

The Propeller 1 Design is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
more details.

You should have received a copy of the GNU General Public License along with
the Propeller 1 Design.  If not, see <http://www.gnu.org/licenses/>.
-------------------------------------------------------------------------------
*/

// RR20140819	Use COGQTY and COGSIZE and HUBSIZE parameters
// RR20140905	Cog RAM addressing 8KB max

module				cog_ram
(
input				clk,
input				ena,

input				w,
input	   [cah:0]	a,
input		[31:0]	d,

output reg	[31:0]	q
);

reg [31:0] ram[COGSIZE*256-1:0];			// Cog Ram (nK*32)

always @(posedge clk)
begin
	if (ena && w)
		ram[a] <= d;
	if (ena)
		q <= ram[a];
end

endmodule
